"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.decodeSignedTransaction = void 0;
const tx_1 = require("@ethereumjs/tx");
const web3_utils_1 = require("web3-utils");
const detect_transaction_type_1 = require("./detect_transaction_type");
const format_transaction_1 = require("./format_transaction");
function decodeSignedTransaction(encodedSignedTransaction, returnFormat) {
    return {
        raw: (0, web3_utils_1.format)({ eth: 'bytes' }, encodedSignedTransaction, returnFormat),
        tx: (0, format_transaction_1.formatTransaction)(Object.assign(Object.assign({}, tx_1.TransactionFactory.fromSerializedData((0, web3_utils_1.hexToBytes)(encodedSignedTransaction)).toJSON()), { hash: (0, web3_utils_1.bytesToHex)((0, web3_utils_1.keccak256)((0, web3_utils_1.hexToBytes)(encodedSignedTransaction))), type: (0, detect_transaction_type_1.detectRawTransactionType)((0, web3_utils_1.hexToBytes)(encodedSignedTransaction)) }), returnFormat),
    };
}
exports.decodeSignedTransaction = decodeSignedTransaction;
//# sourceMappingURL=decode_signed_transaction.js.map